//+------------------------------------------------------------------+
//|                                         _SOLAIMAN_MA_DYN_ATR.mq4 |
//+------------------------------------------------------------------+
#property copyright "OnTheRoad"
#property copyright "SOLAIMAN"

#property indicator_chart_window
#property indicator_buffers 1

#property indicator_color1 Gold
//---- input parameters

#define     HL    0
#define     CO    1

extern int     BASIC_PER   = 20 ;

extern double  pipsteps    = 4 ;

//extern int     atr_per     = 30 ;

/*
extern int  ATR_PER        = 13 ;
extern int  ATR_PER_LARGE  = 55 ;
extern int  ATR_BAK        = 5 ;
*/
/*
MODE_SMA 0 Simple moving average, 
MODE_EMA 1 Exponential moving average, 
MODE_SMMA 2 Smoothed moving average, 
MODE_LWMA 
*/
extern int  ma_method   = MODE_EMA ;
/*
PRICE_CLOSE 0 Close price. 
PRICE_OPEN 1 Open price. 
PRICE_HIGH 2 High price. 
PRICE_LOW 3 Low price. 
PRICE_MEDIAN 4 Median price, (high+low)/2. 
PRICE_TYPICAL 5 Typical price, (high+low+close)/3. 
PRICE_WEIGHTED 6 Weighted close price, (high+low+close+close)/4. 
*/
extern int  applied_price = PRICE_CLOSE ;

extern int  HLCO = HL ;

//---- buffers

double MA[];

double   atr_now , atr_last ;

static int lastbar ;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE,EMPTY, 2 ) ; //  , indicator_color1 
   SetIndexBuffer(0,MA);
   
   double dpcoef1 = 0.0001 / Point ;
   if ( StringFind( Symbol() , "JPY" , 0 ) != -1 ) dpcoef1 = 0.01 / Point ;
   if ( StringFind( Symbol() , "GOLD" , 0 ) != -1 ) dpcoef1 = 0.01 / Point ;

   pipsteps *= dpcoef1 ;
   
   pipsteps *= ( MathSqrt(MathSqrt(Period()))) ;
   
   lastbar = Bars - 1 ;
      
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//----

   int    i , j , counted_bars=IndicatorCounted();
//----
   int limit ;
   
//----
   if ( counted_bars > 0 ) counted_bars -- ;

   limit = Bars - counted_bars ;

   if ( limit >= Bars - BASIC_PER - 1 ) limit = Bars - BASIC_PER - 1 ;
   

   if ( limit < 0 ) return;
   //if ( limit < 3 ) limit = 3 ;
   
   int cmpr ;
   int flag ;
   int ptr ;
   
   double mydif = BASIC_PER * pipsteps * Point ;
   
   for ( i = limit-1 ; i >= 0 ; i -- )
      {
      
      ptr = lastbar ;
      j = i ;
      flag = 0 ;
      while ( ( j < lastbar ) && ( flag == 0 ) )
         {
         cmpr = 0 ;
         if (( HLCO == HL ) && ( ( High[i] - Low[j] ) > mydif ) || ( ( High[j] - Low[i] ) > mydif ) ) cmpr = 1 ;
         else if (( HLCO == CO ) && ( ( Close[i] - Open[j] ) > mydif ) || ( ( Close[i] - Open[j] ) < - mydif ) ) cmpr = 1 ;
         if ( cmpr == 1 )
            {
            ptr = j ;
            flag = 1 ;
            lastbar = j ;
            }
         j ++ ;
         }
      
      if ( ptr-i != 0 ) MA[i] = iMA( NULL , 0 , ptr-i , 0 , ma_method , applied_price , i )  ;
      else MA[i] = MA[i+1] ;

      }

     Comment( "\n ,pipsteps= " , pipsteps , "\n ,Bars= " , Bars , "\n ,mydif= " , mydif , "\n ,lastbar= " , lastbar ) ;
      
//----
   return(0);
  }
//+------------------------------------------------------------------+